FIND_PATH(EIGEN3_INCLUDE_DIR
  NAMES Eigen
  PATH_SUFFIXES include/ include/eigen3/ eigen3/
  PATHS "${PROJECT_SOURCE_DIR}"
  ${EIGEN3_ROOT}
  $ENV{EIGEN3_ROOT}
  /usr/
)

message("Found eigen3 at: ${EIGEN3_INCLUDE_DIR}.")

IF(EIGEN3_INCLUDE_DIR)
  SET(EIGEN3_FOUND TRUE)
ELSE(EIGEN3_INCLUDE_DIR)
  SET(EIGEN3_FOUND FALSE)
ENDIF(EIGEN3_INCLUDE_DIR)

IF(EIGEN3_FOUND)
  MESSAGE(STATUS "Found eigen3 in ${EIGEN3_INCLUDE_DIR}")
ELSE(EIGEN3_FOUND)
  IF(EIGEN3_FIND_REQUIRED)
    MESSAGE(FATAL_ERROR "Could not find \"eigen3\" library")
  ENDIF(EIGEN3_FIND_REQUIRED)
ENDIF(EIGEN3_FOUND)

MARK_AS_ADVANCED(
  EIGEN3_INCLUDE_DIR
)

